package de.intevation.flys.client.client.ui;

import java.util.ArrayList;
import java.util.List;

import com.smartgwt.client.widgets.Canvas;
import com.smartgwt.client.widgets.Label;
import com.smartgwt.client.widgets.layout.VLayout;

import de.intevation.flys.client.shared.model.Data;
import de.intevation.flys.client.shared.model.DataList;
import de.intevation.flys.client.shared.model.User;


/**
 * @author <a href="mailto:ingo.weinzierl@intevation.de">Ingo Weinzierl</a>
 */
public abstract class DatacagePanel extends TextProvider {

    protected String dataName;

    protected User user;

    protected DatacageWidget widget;



    public DatacagePanel() {
        super();
    }


    public DatacagePanel(User user) {
        super();
        this.user = user;
    }


    @Override
    public Canvas create(DataList dataList) {
        Data   data   = dataList.get(0);
        this.dataName = data.getLabel();

        createWidget();

        Canvas label   = new Label(data.getDescription());
        Canvas submit  = getNextButton();
        VLayout layout = new VLayout();
        label.setHeight(25);

        layout.addMember(label);
        layout.addMember(submit);
        layout.setMembersMargin(10);

        return layout;
    }


    protected void createWidget() {
        widget = new DatacageWidget(
            artifact,
            user,
            getOuts(),
            false);

        widget.setHeight100();

        helperContainer.addMember(widget);
    }


    @Override
    public List<String> validate() {
        return new ArrayList<String>();
    }


    public abstract String getOuts();
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
